#include "memorymappedfile.h"

// RXgN^
MemoryMapppedFile::MemoryMapppedFile()
:m_hFile(NULL),m_hMap(NULL),m_pPointer(NULL),m_dwFileSize(0)
{
}

// fXgN^
MemoryMapppedFile::~MemoryMapppedFile()
{
	this->Release();	
}

//-------------------------------------------//
// 
//-------------------------------------------//
void MemoryMapppedFile::Release(){
	if(m_pPointer != NULL){
		UnmapViewOfFile( m_pPointer );
		m_pPointer = NULL;
	}
	if( m_hMap != NULL ){
		CloseHandle( m_hMap );
		m_hMap = NULL;
	}
	if( m_hFile != NULL ){
		CloseHandle( m_hFile );
		m_hFile  = NULL;
	}
	m_dwFileSize = 0;
}


//-------------------------------------------//
//	t@CI[v
//	
//	F	FileName		t@C
//			ReadWriteFlag	ǂݏtO
//			OpenFlag		t@CI[vtO
//-------------------------------------------//
bool MemoryMapppedFile::Open( const TCHAR* FileName, DWORD ReadWriteFlag, DWORD OpenFlag)
{
	// t@CI[v
	m_hFile = CreateFile( FileName, ReadWriteFlag, 0, 0, OpenFlag, FILE_ATTRIBUTE_NORMAL, NULL );
	if( m_hFile == INVALID_HANDLE_VALUE )
		return false;// I[vs

	// t@C}bsOIuWFNg쐬
	DWORD mapflag = PAGE_READWRITE;
	if( ReadWriteFlag == GENERIC_READ )
		mapflag = PAGE_READONLY;   // ǂݍݐpɐݒ
	m_hMap = CreateFileMapping( m_hFile, 0, mapflag, 0, 0, FileName );
	if( m_hMap <= 0 ){
		CloseHandle( m_hFile );
		m_hFile = NULL;
		return false;
	}

	// |C^擾
	DWORD mapviewflag = FILE_MAP_WRITE;
	if( mapflag == PAGE_READONLY )
		mapviewflag = FILE_MAP_READ;	// ǂݎpɐݒ
	m_pPointer = MapViewOfFile( m_hMap, mapviewflag, 0, 0, 0);
	if( m_pPointer == NULL){
		CloseHandle( m_hMap );
		CloseHandle( m_hFile );
		m_hMap = NULL;
		m_hFile = NULL;
		return false;
	}

	// t@CTCY擾
	DWORD dwFileSizeHigh;	// t@CTCY4Gȏゾꍇɏ32bit͕KvɂȂ
	m_dwFileSize = ::GetFileSize( m_hFile, &dwFileSizeHigh );

	return true;
}


//-----------------------------------------------------------//
//	t@Cf[^|C^擾
//
//	߂lFt@Cf[^̐擪|C^
//-----------------------------------------------------------//
void* MemoryMapppedFile::GetPtr(){
	return m_pPointer;
}
//-----------------------------------------------------------//
//	t@CTCY擾
//
//	߂lFt@CTCY
//-----------------------------------------------------------//
DWORD MemoryMapppedFile::GetSize(){
	return m_dwFileSize;
}
