#define  _CRT_SECURE_NO_WARNINGS
#include "package.h"


// u֐(WȂ̂ō܂)
// source		Ώە
// pattern		uΏۃp^[
// placement	u
std::basic_string<TCHAR> _treplace (
    const std::basic_string<TCHAR> & source,
    const std::basic_string<TCHAR> & pattern,
    const std::basic_string<TCHAR> & placement
)
{
    std::basic_string<TCHAR> result;
    std::basic_string<TCHAR>::size_type pos_before = 0;
    std::basic_string<TCHAR>::size_type pos = 0;
    std::basic_string<TCHAR>::size_type len = pattern.size();
	while ((pos = source.find(pattern, pos)) != std::basic_string<TCHAR>::npos) {
        result.append(source, pos_before, pos - pos_before);
        result.append(placement);
        pos += len;
        pos_before = pos;
    }
    result.append(source, pos_before, source.size() - pos_before);
    return result;
}

//------------------------------------------------//
//	t@C񋓂
//
//	F	Dir			fBNgpX
//			WildCard	ChJ[h
//------------------------------------------------//
void Package::EnumFiles(const TCHAR* Dir,const TCHAR* WildCard)
{
	std::basic_string<TCHAR> dir = Dir;
	std::basic_string<TCHAR> relativedir = Dir;
	dir += _T("/");
	dir += WildCard;
	WIN32_FIND_DATA fd = {};
	HANDLE hFind = FindFirstFile(dir.c_str(),&fd);
	if(hFind == INVALID_HANDLE_VALUE)
		return;


	do{

		// u.vƁu..v͔΂܂
		if(_tcscmp(fd.cFileName,_T(".")) != 0 && _tcscmp(fd.cFileName,_T("..")) != 0)
		{
			// tH_̏ꍇ
			if(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				std::basic_string<TCHAR> childdir = Dir;
				childdir += _T("/");
				childdir += fd.cFileName;
				// qtH_Ɉڂ
				this->EnumFiles(childdir.c_str(),WildCard);				
			}
			// t@C
			else
			{
				std::basic_string<TCHAR> tmp = relativedir;
				tmp += _T("/");
				tmp += fd.cFileName;
				std::basic_string<TCHAR> correct = _treplace(tmp,_T("\\"),_T("/"));
				// t@C擾
				m_FileNameList.push_back(correct.c_str());
			}
		}

	}while(FindNextFile(hFind,&fd) == TRUE);
}

// RXgN^
Package::Package(){
	memset(m_FormatName,0,sizeof(m_FormatName));
}
// fXgN^
Package::~Package(){
}

//------------------------------------------------//
//	tH[}bg̃Zbg
//
//	FFormatName	tH[}bg
//
//	߂lFtrue:	Zbg
//			false:	Zbgs
//------------------------------------------------//
bool Package::SetFormatName(TCHAR FormatName[PACKAGEFORMATMAX]){
	
	_tcscpy(m_FormatName,FormatName);
	return true;
}

//------------------------------------------------//
//	wfBNg̑St@CpbP[W
//
//	F	DirName			fBNgist@C̑΃pXj
//			OutFileName		o̓t@C(pbP[Wt@C)
//
//	߂lFtrue:	
//			false:	s
//------------------------------------------------//
bool Package::CreatePackage(const TCHAR* DirName,const TCHAR* OutFileName)
{

	std::basic_string<TCHAR> dir = DirName;
	// t@C
	this->EnumFiles(dir.c_str(),_T("*.*"));


	HANDLE hOutFile = CreateFile(OutFileName, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hOutFile == INVALID_HANDLE_VALUE){
		MessageBox(NULL, _T("pbP[Wt@C쐬Ɏs܂"), NULL, MB_ICONWARNING);
		return false;
	}

	DWORD dwWriteByte = 0;// ۂɏ񂾃oCg

	// wb_[
	PackageHeader header = {};
	_tcscpy(header.FormatName,m_FormatName);		// tH[}bg
	header.FileNum = (UINT)m_FileNameList.size();	// t@C
	WriteFile(hOutFile, &header,sizeof(header), &dwWriteByte, NULL);	// wb_[

	// f[^
	std::list<std::basic_string<TCHAR> >::iterator it;
	for(it = m_FileNameList.begin();it != m_FileNameList.end();++it)
	{
		MemoryMapppedFile File;
		if(!File.Open(it->c_str(),GENERIC_READ)){
			MessageBox(NULL,_T("t@CI[vɎs܂B"),it->c_str(),MB_ICONWARNING);
			CloseHandle(hOutFile);	// pbP[Wt@CN[Y
			return false;// I[vs
		}

		FileData data = {};
		_tcscpy(data.FileName,it->c_str());			// t@C
		data.Size = File.GetSize();					// t@Cf[^TCY
		data.Tail = '\0';							// f[^

		
		WriteFile(hOutFile,data.FileName,sizeof(data.FileName), &dwWriteByte, NULL);	// t@C
		WriteFile(hOutFile, &data.Size,sizeof(data.Size), &dwWriteByte, NULL);			// t@Cf[^TCY
		WriteFile(hOutFile, File.GetPtr(),File.GetSize(), &dwWriteByte, NULL);			// t@Cf[^
		WriteFile(hOutFile, &data.Tail,sizeof(BYTE), &dwWriteByte, NULL);				// f[^

	}

	CloseHandle(hOutFile);	// pbP[Wt@CN[Y

	return true;
}

//-----------------------------------------------//
//	pbP[Wt@CJ
//
//	FFileName	pbP[Wt@C
//
//	߂lFtrue:	
//			false:	s
//-----------------------------------------------//
bool Package::OpenPackage(const TCHAR* FileName){

	if(!m_PackageFile.Open(FileName)){
		MessageBox(NULL,_T("t@CI[vɎs܂B"),FileName,MB_ICONWARNING);
		m_PackageFile.Release();
		return false;// I[vs
	}
	
	return this->LoadPackage((BYTE*)m_PackageFile.GetPtr());
}

//-----------------------------------------------//
//	pbP[Wf[^ǂݎ
//
//	FPtr	pbP[Wf[^̐擪|C^
//
//	߂lFtrue:	
//			false:	s
//-----------------------------------------------//
bool Package::LoadPackage(BYTE* Ptr)
{
	BYTE* ptr = Ptr;
	PackageHeader header = {}; 
	memcpy(&header,ptr,sizeof(header));	// wb_[ǂݍ
	ptr += sizeof(header);

	// tH[}bg̃`FbN
	if(_tcscmp(header.FormatName,m_FormatName) != 0){
		MessageBox(NULL,_T("tH[}bgႢ܂"),NULL,MB_ICONWARNING);
		m_PackageFile.Release();
		return false;// tH[}bgႤ
	}
	

	// f[^ǂݍ
	for(unsigned int i = 0;i < header.FileNum;++i){
		FileData data = {};
		memcpy(data.FileName,ptr,sizeof(data.FileName));	// t@Cǂݍ
		ptr += sizeof(data.FileName);
		memcpy(&data.Size,ptr,sizeof(data.Size));			// t@CTCYǂݍ
		ptr += sizeof(data.Size);
		data.Ptr = ptr;										// t@Cf[^擪|C^
		ptr += data.Size;
		memcpy(&data.Tail,ptr,sizeof(data.Tail));			// f[^
		ptr += sizeof(data.Tail);

		// f[^}
		m_FileDataMap.insert(std::pair<std::basic_string<TCHAR>,FileData>(data.FileName,data));
	}

	return true;
}



//------------------------------------------------//
//	w̃t@C̃f[^擾
//
//	F	FileName	t@C
//			pOutData	擾t@Cf[^
//
//	߂lFtrue	:
//			false	:sit@CȂj
//------------------------------------------------//
bool Package::GetFileData(const TCHAR* FileName,FileData* pOutData)
{
	if(m_FileDataMap.find(FileName) != m_FileDataMap.end()){
		_tcscpy(pOutData->FileName,m_FileDataMap[FileName].FileName);
		pOutData->Ptr = m_FileDataMap[FileName].Ptr;
		pOutData->Size = m_FileDataMap[FileName].Size;
		pOutData->Tail = m_FileDataMap[FileName].Tail;
		return true;
	}
	
	MessageBox(NULL,_T("pbP[Wt@CɎw̃t@C܂"),NULL,MB_ICONWARNING);
	return false;
}

//------------------------------------------------//
//	pbP[Wt@CɊi[Ăt@C
//
//	߂lFt@C
//------------------------------------------------//
int Package::GetFileNum(){
	return (int)m_FileDataMap.size();
}
